SUB Preprocess SHARED

LOCAL B$,SaveVar$,Trigger$
LOCAL A,TheDataType,Tmp,SelectFlag,DontSend,Size,Hi,Lo,Leng
SHARED StackSize,Pass1Line$   ' << *** these are referenced in CheckColons

Source$ = EXTRACT$(ProjName$,".") + ".BAS"

PreChannel = 1

OPEN Source$ FOR INPUT AS PreChannel
ReadSrcLine:
WHILE NOT EOF(PreChannel)
  LINE INPUT #PreChannel,Pass1Line$
  LongLine:
  Pass1Line$ = RTRIM$(Pass1Line$)
  If Right$(Pass1Line$,2) = " _" then
    Pass1Line$ = MID$(Pass1Line$,1,Len(Pass1Line$)-1)
    Tmp$ = Pass1Line$
    LINE INPUT #PreChannel,Pass1Line$
    Pass1Line$ = Tmp$ + Pass1Line$
    Goto LongLine
  END IF
'*************************************************************************

  MultiIF:
  HasColon:
  INCR LinesRead
  ParseAgain:
  StackSize = QuikParse(Pass1Line$)
  CheckColons

'==================================================================
'               CONVERT   {AND's}   to   {THEN IF's}
'==================================================================

  IF UCASE$(Stk$(1)) = "IF" THEN
    ReParseFlag = 0
    AddSemiFlag = 0
    IF Right$(Pass1Line$,1) = ";" THEN AddSemiFlag = -1
    FOR A = 2 TO StackSize
      IF UCASE$(Stk$(A)) = "AND" THEN
        Stk$(a) = "THEN IF"
        ReParseFlag = -1
      END IF
    NEXT
    Pass1Line$ = ""
    FOR A = 1 TO StackSize
      Pass1Line$ = Pass1Line$ + Stk$(A) + " "
    NEXT
    IF AddSemiFlag THEN
      Pass1Line$ = Pass1Line$ + " ;"
      INCR StackSize
      Stk$(StackSize) = ";"
    END IF
    IF ReParseFlag THEN GOTO ParseAgain
  END IF

'**********************************************************************
'            This bit of code handles a case like a(1) = b(2)
'**********************************************************************

  IF StackSize = 5 AND Stk$(3) = "=" AND DataType(Stk$(1)) = %NumVar THEN
    IF UCASE$(Stk$(1)) = "IF" THEN EXIT IF
    Build "_Tmp = "     + Stk$(4) + " " + Stk$(5)
    Build Stk$(1) + " " + Stk$(2) + " = _Tmp"
    Addvar$ "_Tmp"
    DontSend = %True
  END IF

  IF StackSize = 5 AND Stk$(3) = "=" AND DataType(Stk$(1)) = %StrVar THEN
    IF UCASE$(Stk$(1)) = "IF" THEN EXIT IF
    Build "_Tmp$ = "    + Stk$(4) + " " + Stk$(5)
    Build Stk$(1) + " " + Stk$(2) + " = _Tmp$"
    AddVar$ "_Tmp$"
    DontSend = %True
  END IF

'*************************************************************************

  Trigger$ = UCASE$(Stk$(1))

  SELECT CASE Trigger$

    CASE "REM"
    DontSend = %True

    CASE "$FAR"
    MemModel = 4
    DontSend = %True

    CASE ""
    DontSend = %True

'***************************************************************************

    CASE "DATA"
    INCR DataFlag
    ON ERROR GOTO StartCompiler

    IF DataFlag = 1 THEN
      KILL "DataStmt.$$$"
    END IF

    StartCompiler:

    ON ERROR GOTO ERRORHANDLER
    A$ = "DW "
    DataHandle = FREEFILE
    FOR a = 2 to StackSize
      IF DataType(Stk$(A)) = %Numvar THEN Stk$(A) = "'" + Stk$(A) + "'"
      a$ = a$ + Stk$(a) + ","
    NEXT
    A$ = SPACE$(13) + RTRIM$(A$,",")
    OPEN "DataStmt.$$$" FOR APPEND AS DataHandle
    PRINT #DataHandle,a$
    CLOSE DataHandle
    DontSend = %True

'***************************************************************************

    CASE "CONST"
    INCR ConstantCount
    ConstName$(ConstantCount)  = UCASE$(Stk$(2))
    Stk$(2) = Stk$(2) + SPACE$(20)
    Stk$(2) = MID$(Stk$(2),1,20)
    Pass1Line$ = "ASM " + Cap$(Stk$(2)) + "EQU" + SPACE$(10) + LTRIM$(Stk$(4))
    Build Pass1Line$
    DontSend = %True

'========================================

    CASE "ENUM"
    For A = 2 to StackSize
      INCR ConstantCount
      ConstName$(ConstantCount)  = UCASE$(Stk$(a))
      Tmp$ = Stk$(a) + SPACE$(20)
      Tmp$ = Cap$(MID$(Tmp$,1,20))
      Pass1Line$ = "ASM " + Tmp$ + "EQU" + SPACE$(10) + Num$(A-1)
      Build Pass1Line$
    NEXT
    DontSend = %True

'======================================================

    CASE "$INCLUDE"
    Fil$ = REMOVE$(Stk$(2),CHR$(34))
    INCR PreChannel
    OPEN Fil$ FOR INPUT AS PreChannel
    GOTO ReadSrcLine



    CASE "$UNDEFINE"
    Pass1Line$ = UCASE$(Stk$(2))
    REPLACE Pass1Line$ WITH " " IN Func$
    DontSend = %True


    CASE "$ASM"
    WHILE NOT EOF(PreChannel)
      LINE INPUT #PreChannel,Pass1Line$
      Spare$ =  Pass1Line$
      Quikparse Pass1Line$
      IF UCASE$(Stk$(1)) = "$ASM" THEN EXIT LOOP
      Pass1Line$ = "ASM " + Spare$
      Build Pass1Line$
    WEND
    DontSend = %True



    CASE "$COMMENT"
    WHILE NOT EOF(PreChannel)
      LINE INPUT #PreChannel,Pass1Line$
      Quikparse Pass1Line$
      IF UCASE$(Stk$(1)) = "$COMMENT" THEN EXIT LOOP
    WEND
    DontSend = %True



    CASE  "SELECT"
    SaveVar$ = Stk$(3)
    SelectFlag = 1
    DontSend = %True



    CASE "CASE"
    IF SelectFlag > 1 THEN
      Build "END IF"
    END IF
    Build "IF " + SaveVar$ + " = " + Stk$(2) + " THEN"
    INCR SelectFlag
    DontSend = %True



    CASE "END"
    IF UCASE$(Stk$(2)) = "SUB" OR UCASE$(Stk$(2)) = "FUNCTION" THEN
      InProc = %False
    END IF
    IF UCASE$(Stk$(2)) = "SELECT" THEN
      Build "END IF"
      SelectFlag = 0
      DontSend = %True
    END IF



    CASE "WHILE"
    Pass1Line$ = ""
    FOR A = 2 TO StackSize
      Pass1Line$ = Pass1Line$ + Stk$(A) + " "     'WHILE A < > B
    NEXT
    IF StackSize = 2 THEN         'WHILE A
      Pass1Line$ = Pass1Line$ + " <> 0"
    END IF
    IF StackSize = 3 THEN         'WHILE NOT A
      Pass1Line$ = Pass1Line$ + " = 0"
    END IF
    Build "DO"
    Build "IF " + Pass1Line$ + " THEN"
    DontSend = %True



'*********   This code tests for and handles single line IF-THEN's ********

    CASE "IF"

    IF UCASE$(Stk$(StackSize)) <> "THEN" THEN

      FOR Tmp = 1 TO StackSize
        IF UCASE$(Stk$(Tmp)) = "THEN" THEN EXIT FOR
      NEXT

      Tmp$ = ""
      FOR A = 1 TO Tmp
        Tmp$ = Tmp$ + Stk$(A) + " "
      NEXT
      Build Tmp$
      Tmp$ = ""
      INCR Tmp

      FOR A = Tmp TO StackSize
        Tmp$ = Tmp$ + Stk$(A) + " "
      NEXT

'**************************************************************************
'This next block handles cases like:  IF A=1 then IF B=2 THEN doSomething
'**************************************************************************

      IF UCASE$(Stk$(Tmp)) = "IF" THEN
        Pass1Line$ = Tmp$
        INCR MultiFlag
        GOTO MultiIF
      ELSE
        Build Tmp$
        Tmp$ = ""
        Build "END IF"
        DontSend = %True
      END IF
    END IF

    While MultiFlag
      Build "END IF"
      DECR MultiFlag
    Wend

'********************** End of single line IF THEN code ********************


    CASE  "WEND"
    Pass1Line$ = "ELSE:EXIT LOOP:END IF:LOOP" : GOTO ParseAgain



    CASE "EXIT"
    IF UCASE$(Stk$(2)) = "WHILE" THEN
      Build "EXIT LOOP"
      DontSend = %True
    END IF




    CASE "SUB","FUNCTION"
    InProc = %True
    LocalProcName$ = Remove$(Stk$(2),"$")
    InProc = %True
    INCR ProcCount
    Proc$(ProcCount,1) = UCASE$(Stk$(2))
    Proc$(ProcCount,2) = LTRIM$(Str$(StackSize-2))
    FOR Tmp = 3 TO StackSize
      IF UCASE$(Stk$(Tmp)) = "PUBLIC" THEN EXIT FOR
      Proc$(ProcCount,Tmp) = UCASE$(Stk$(Tmp))
    NEXT



    CASE "DECLARE"
    DontSend = %True
    INCR ExtrnCnt
    Externals$(ExtrnCnt) = Cap$(Stk$(3))
    INCR ProcCount
    Proc$(ProcCount,1) = UCASE$(Stk$(3))
    Proc$(ProcCount,2) = LTRIM$(Str$(StackSize-3))
    FOR Tmp = 4 TO StackSize
      Proc$(ProcCount,Tmp) = UCASE$(Stk$(Tmp))
    NEXT



    CASE "DIM"
'*************************************************************************
' The purpose here is to build a table of valid string array names and
' their associated element counts and to create the appropriate DB line.
'*************************************************************************
    LocalFlag = 0

    IF InProc = %True AND UCASE$(Stk$(2)) = "LOCAL" THEN
      TempProcName$ = Stk$(3)
      LocalFlag = 1
      Stk$(3) = "L_" + LocalProcName$ + "_" + Stk$(3)
    END IF

    IF DataType(Stk$(2+LocalFlag)) = %StrVar THEN
      INCR StrArrayCount
      StrArrayName$(StrArrayCount) = Stk$(2+LocalFlag)
      Size = Val(Stk$(3+LocalFlag))

      IF Size = 0 THEN                        'Size a simple variable
        DECR StrArrayCount
        StrArrayName$(StrArrayCount) = ""
      ELSE
        StrArrayLeng(StrArrayCount) = Size    'Size an array
        FOR A = 1 TO %TableSize
          IF VarName$(A) = "" THEN
            VarName$(A) = UCASE$(Stk$(2+LocalFlag))     'Add Var Name to table
            EXIT FOR
          END IF
        NEXT
      END IF
    END IF

    Var$ = Stk$(2+LocalFlag)

    IF DataType(Var$) = %StrVar THEN
      INCR Literals
      INCR FarDataCount
      VarName$(Literals) = UCASE$(Var$)

      PadVar Var$

      Leng = Val(Stk$(3+LocalFlag))
      Size = Val(Stk$(4+LocalFlag))

      IF Leng = 0 THEN
        Swap Leng,Size
      END IF

      IF Size = 0 THEN
        Size = Leng
        Leng = 1
      END IF

      Hi   =  INT(Leng/256)
      Lo   =  Leng - Hi
      Tmp$ =  Num$(Hi) + "," + Num$(Lo) + ","

      IF Leng > 1 THEN
        FarData$(FarDataCount) = Var$ + " DB " + Tmp$ + Str$((Leng*Size) + Leng) + " DUP(?)"
      ELSE
        FarData$(FarDataCount) = Var$ + " DB" + Str$((Leng*Size) + Leng) + " DUP(?)"
      END IF

      INCR TotalData, 2 + (Leng*Size) + Leng
      Tmp$ = ""
    END IF

    IF DataType(Var$) = %Numvar THEN

      INCR FarDataCount
      INCR Literals

      VarName$(Literals) = UCASE$(Var$)

      PadVar Var$

      Size = Val(Stk$(3+LocalFlag))
      FarData$(FarDataCount) = Var$ + " DB " + Str$((2 * Size) + 2) + " DUP(?) "
      INCR TotalData, (2 * Size) + 2
    END IF

    DontSend =%True
    AddVar$ Stk$(2 + LocalFlag)
    If LocalFlag THEN Build "LOCAL " + TempProcName$

  END SELECT

  IF DontSend = %False THEN
    Build Pass1Line$
  END IF

  DontSend = %False

  IF Colon$ > "" THEN
    Pass1Line$ = Colon$
    GOTO HasColon
  END IF

WEND


IF PreChannel > 1 THEN
  Close PreChannel
  DECR  PreChannel
  Goto  ReadSrcLine
END IF

CLOSE

FreeMem& = FRE(-1)        'Used in the final report only

OPEN Destin$   FOR OUTPUT AS 2
OPEN SubProcs$ FOR OUTPUT AS 4

InProc        = %False   'True when parsing within a SUB or FUNCTION

END SUB






FUNCTION Parse(Parameter$)
SHARED Stk$()
REDIM  Stk$(256)

Lin$          =      LTRIM$(Parameter$)
IF Lin$       =      ""  THEN EXIT FUNCTION
IsWhite       =      INSTR(Parameter$,CHR$(255))

DO
  Tmp$ = EXTRACT$(Lin$," ")
  INCR Ndx
  Stk$(Ndx) = Tmp$
  Tmp = Len(Tmp$)
  IF Tmp THEN
    INCR Tmp
    Lin$ = LTRIM$(MID$(Lin$,Tmp))
  ELSE
    DECR Ndx
    EXIT LOOP
  END IF
LOOP

IF UCASE$(Stk$(1)) = "DEF" AND  UCASE$(Stk$(2)) = "SEG" THEN
  Stk$(1) = "DEFSEG"
  ARRAY DELETE Stk$(2)
  DECR Ndx
END IF


IF Ndx = 4 THEN
  IF Stk$(2) = "=" THEN
    Tmp$ = UCASE$(Stk$(3))
    IF _
    NOT IsUsrFunc(Tmp$) _
    AND DataType(Tmp$) <> %Func _
    AND INSTR(Stk$(4),"-") = 0 THEN
    Stk$(2) = Stk$(3)
    Stk$(3) = Stk$(4)
    Stk$(4) = Stk$(1)
    Stk$(1) = "ARRAYGET"
  END IF
END IF
END IF


IF Ndx = 4 AND Stk$(3) = "=" AND UCASE$(STK$(1)) <> "IF"  THEN
  Stk$(3) = Stk$(2)
  Stk$(2) = Stk$(1)
  Stk$(1) = "ARRAYPUT"
END IF


IF Stk$(2) = "=" THEN
  SWAP Stk$(1),Stk$(2)
  GOTO ParseSpeedUp
END IF


IF UCASE$(Stk$(1)) = "EXIT"  THEN
  Stk$(1) = Stk$(1) + Stk$(2)
  ARRAY DELETE Stk$(2)
  DECR Ndx
  GOTO ParseSpeedUp
END IF


IF UCASE$(Stk$(1)) = "END"  THEN
  Stk$(2) = UCASE$(Stk$(2))
  SELECT CASE Stk$(2)
    CASE "IF","SELECT","SUB","FUNCTION","REPEAT"
    Stk$(1) = Stk$(1) + Stk$(2)
    ARRAY DELETE Stk$(2)
    DECR Ndx
    IF Ndx = 0 THEN INCR Ndx
  END SELECT
  GOTO ParseSpeedUp
END IF


IF UCASE$(Stk$(1)) = "ARRAY" THEN
  Stk$(1) = Stk$(1) + Stk$(2)
  ARRAY DELETE Stk$(2)
  DECR Ndx
  GOTO ParseSpeedUp
END IF

ParseSpeedUp:

'****  Restore white space  ***

If IsWhite THEN
  FOR Tmp = 1 TO Ndx
    REPLACE CHR$(255) WITH " " IN Stk$(Tmp)
  NEXT
END IF


IF UCASE$(Stk$(1)) = "PRINT" AND MID$(Stk$(2),1,1) = "#" THEN
  Stk$(1) = "PRINT#"
  Stk$(2) = REMOVE$(Stk$(2),ANY " #")
  IF Stk$(2) = "" THEN
    ARRAY DELETE Stk$(2)
    DECR Ndx
  END IF
END IF


IF UCASE$(Stk$(1)) = "LINE" AND  UCASE$(MID$(Stk$(2),1,5)) = "INPUT" THEN
  Stk$(1) = "LINEINPUT#"
  ARRAY DELETE Stk$(2)
  Stk$(2) = REMOVE$(Stk$(2),ANY " #")
  DECR Ndx
END IF


IF UCASE$(Stk$(1)) = "INPUT" AND MID$(Stk$(2),1,1) = "#" THEN
  Stk$(1) = "INPUT#"
  Stk$(2) = REMOVE$(Stk$(2),ANY " #")
  IF Stk$(2) = "" THEN
    ARRAY DELETE Stk$(2)
    DECR Ndx
  END IF
END IF


IF UCASE$(Stk$(1)) = "IF" THEN

  IF Stk$(3) = "=" AND Stk$(4) = "<" THEN
    Stk$(3) = "LE"
    Stk$(4) = Stk$(5)
    DECR Ndx
    EXIT IF
  END IF


  IF Stk$(3) = "<" AND Stk$(4) = "=" THEN
    Stk$(3) = "LE"
    Stk$(4) = Stk$(5)
    DECR Ndx
    EXIT IF
  END IF


  IF Stk$(3) = ">" AND Stk$(4) = "=" THEN
    Stk$(3) = "GE"
    Stk$(4) = Stk$(5)
    DECR Ndx
    EXIT IF
  END IF


  IF Stk$(3) = "=" AND Stk$(4) = ">" THEN
    Stk$(3) = "GE"
    Stk$(4) = Stk$(5)
    DECR Ndx
    EXIT IF
  END IF


  IF Stk$(3) = "<" AND Stk$(4) = ">" THEN
    Stk$(3) = "NE"
    Stk$(4) = Stk$(5)
    DECR Ndx
    EXIT IF
  END IF


  IF Stk$(3) = ">" AND Stk$(4) = "<" THEN
    Stk$(3) = "NE"
    Stk$(4) = Stk$(5)
    DECR Ndx
    EXIT IF
  END IF


  IF Stk$(3) = "=" THEN
    Stk$(3) = "EQ"
    EXIT IF
  END IF


  IF Stk$(3) = "<" THEN
    Stk$(3) = "LT"
    EXIT IF
  END IF


  IF Stk$(3) = ">" THEN
    Stk$(3) = "GT"
    EXIT IF
  END IF


  IF UCASE$(Stk$(2)) = "NOT"  THEN
    Stk$(2) = "0"
    Stk$(4) = Stk$(3)
    Stk$(3) = "EQ"
    EXIT IF
  END IF


  IF UCASE$(Stk$(3))="THEN" THEN
    Stk$(3) = "NE"
    Stk$(4) = "0"
    EXIT IF
  END IF
END IF


IF Ndx = 2 AND Stk$(2) = ":" THEN
  Stk$(2) = Stk$(1) + ":"
  Stk$(1) = "_LABEL"
  INCR Ndx
END IF


IF UCASE$(Stk$(1)) = "ASM" THEN
  Lin$ = LTRIM$(Parameter$)
  Lin$ = MID$(Lin$,4)
  Stk$(1) = "ASM"
  Stk$(2) = Lin$
  Ndx = 1
END IF

Parse = Ndx
END FUNCTION




FUNCTION Trim$(A$)
Trim$ = LTRIM$(RTRIM$(A$))
END FUNCTION




FUNCTION IsInteger(A$)
X = VERIFY(A$,"-0123456789")
IF X = 0 THEN
  IsInteger = -1
ELSE
  IsInteger = 0
END IF
END FUNCTION



SUB Hex2Dec(A$)
IF LEFT$(UCASE$(A$),2) ="&H" THEN
  A$ = TRIM$(STR$(VAL(A$)))
END IF
IF LEFT$(UCASE$(A$),2) ="&B" THEN
  A$ = TRIM$(STR$(VAL(A$)))
END IF
END SUB





FUNCTION AddVar$(A$) SHARED
LOCAL Var$,AddFlag,A

FOR A = 1 to LocalNameCount
  IF UCASE$(A$) = LocalName$(A) THEN
    AddVar$ = A$
    EXIT FUNCTION
  END IF
NEXT


IF UCASE$(A$) = "COMMAND$" THEN
  Use.Command = %True
  AddVar$ = A$
  EXIT FUNCTION
END IF


IF IsFunc(A$) THEN
  AddVar$ = A$
  EXIT FUNCTION
END IF


IF IsConst(A$) THEN
  AddVar$ = GetConstantName$(A$)
  EXIT FUNCTION
END IF


IF UCASE$(A$) = "AX" THEN
  Addvar$ = A$
  EXIT FUNCTION
END IF


IF MID$(A$,1,12) = "Word Ptr[BP+" THEN
  Addvar$=A$
  EXIT FUNCTION
END IF


IF UCASE$(MID$(A$,1,6)) = "$TRING" THEN
  Addvar$ = LCASE$(A$)
  EXIT FUNCTION
END IF


IF UCASE$(MID$(A$,1,2)) = "$_" THEN
  Addvar$ = LCASE$(A$)
  EXIT FUNCTION
END IF


REPLACE "." WITH "_dot_" IN A$              ' changes A.1 to A_dot_1

IF IsInteger(A$) THEN
  AddVar$ = A$
  EXIT FUNCTION
END IF

Var$ = UCASE$(A$)


FOR A = 1 TO %TableSize
  IF Var$ = VarName$(A) THEN EXIT FOR     'Already allocated
  IF VarName$(A) = "" THEN
    VarName$(A) = Var$                    'not allocated, Add to table
    AddFlag = %True
    EXIT FOR
  END IF
NEXT

IF AddFlag THEN                               'Allocate variable if necessary
  PadVar Var$
  INCR Literals
  IF INSTR(Var$,"$") THEN                     'its a String Variable
    INCR FarDataCount
    FarData$(FarDataCount) = Var$ + " DB  MaxString  DUP(?)"
    INCR TotalData,BasmStrings
  ELSE                                        'its a Numeric Variable
    NearData$(Literals)    = Var$ + " DW  0"
  END IF
END IF

Value$ = Stk$(3)

IF Value$ = "-" THEN
  Value$ = Value$ + Stk$(4)
  ARRAY DELETE Stk$(4)
END IF

AddVar$ = Trim$(Var$)
END FUNCTION




SUB Emit(A$) SHARED
IF InProc THEN
  ? #4,A$
ELSE
  ? #2,A$
END IF
END SUB



FUNCTION Num$(A)
Tmp$ = LTRIM$(STR$(A))
IF LEN(Tmp$) = 1 THEN
  Num$ = "0" + Tmp$
ELSE
  Num$ = Tmp$
END IF
END FUNCTION




SUB IfThenPush(A)
SHARED IfThenStack(),SP
DECR SP
IF SP < 0 THEN SP = 256
IfThenStack(SP) = A
END SUB




FUNCTION IfThenPop
SHARED IfThenStack(),SP
IfThenPop = IfThenStack(SP)
IfThenStack(SP) = 0
INCR SP
END FUNCTION




SUB ElsePush(A)
SHARED ElseStack(),ElseSP
DECR ElseSP
IF ElseSP < 0 THEN ElseSP = 256
ElseStack(ElseSP) = A
END SUB




FUNCTION ElsePop
SHARED ElseStack(),ElseSP
ElsePop = ElseStack(ElseSP)
ElseStack(ElseSP) = 0
INCR ElseSP
END FUNCTION



SUB LoopPush(A)
SHARED LoopStack(),LoopSP
DECR LoopSP
IF LoopSP < 0 THEN LoopSP = 256
LoopStack(LoopSP) = A
END SUB




FUNCTION LoopPop
SHARED LoopStack(),LoopSP
LoopPop = LoopStack(LoopSP)
LoopStack(LoopSP) = 0
INCR LoopSP
END FUNCTION




SUB ForPush(A)
SHARED ForStack(),ForSP
DECR ForSP
IF ForSP < 0 THEN ForSP = 256
ForStack(ForSP) = A
END SUB



FUNCTION ForPop
SHARED ForStack(),ForSP
ForPop = ForStack(ForSP)
ForStack(ForSP) = 0
INCR ForSP
END FUNCTION



SUB RepeatPush(A)
SHARED RepeatStack(),RepeatSP
DECR RepeatSP
IF RepeatSP < 0 THEN RepeatSP = 256
RepeatStack(RepeatSP) = A
END SUB



FUNCTION RepeatPop
SHARED RepeatStack(),RepeatSP
RepeatPop = RepeatStack(RepeatSP)
RepeatStack(RepeatSP) = 0
INCR RepeatSP
END FUNCTION




SUB PrintSrc
SHARED SourceLine$,SourceFlag%
IF SourceFlag% THEN
  REPLACE CHR$(255) WITH CHR$(32) IN SourceLine$
  Emit ";" + REPEAT$(70,"*")
  Emit ";" + SourceLine$
  Emit ";" + REPEAT$(70,"*")
END IF
END SUB




FUNCTION DataType(Arg$) SHARED

IF IsFunc(Arg$) THEN
  DataType = %Func
  EXIT FUNCTION
END IF

IF INSTR(Arg$,CHR$(34)) THEN
  DataType = %StrLit
  EXIT FUNCTION
END IF

IF INSTR(Arg$,"$") THEN
  DataType = %StrVar
  EXIT FUNCTION
END IF

IF IsInteger(Arg$) THEN
  DataType = %Number
  EXIT FUNCTION
END IF

IF INSTR(UCASE$(Arg$),ANY "ABCDEFGHIJKLMNOPQRSTUVWXYZ") > 0 THEN
  DataType = %NumVar
END IF
END FUNCTION




SUB AddToLiteralTable(Parm$) SHARED
LOCAL A,Tmp$,Element$,Arg$

Arg$            =   REMOVE$(Parm$,CHR$(34))
SharedLiteral$  =   ""

FOR A = 1 TO Literals
  IF INSTR (NearData$(A),"$tring_") THEN
    Tmp$  = LTRIM$(MID$(NearData$(A),18))
    Tmp$  = EXTRACT$  (Tmp$,",0")
    Tmp$  = REMOVE$   (Tmp$, CHR$(34))
    IF Arg$ = Tmp$ THEN
      SharedLiteral$ = MID$(NearData$(A),1,12)
      EXIT SUB
    END IF
  END IF
NEXT

INCR Literals
Element$ = Num$(Literals-%Offset)

IF Arg$ = "" THEN
  NearData$(Literals) = "$tring_" + Element$ + "     DB  0,0"
  INCR TotalData,2
ELSE
  Arg$ = CHR$(34) + Arg$ + CHR$(34) +",0"
  NearData$(Literals) = "$tring_" + Element$ + "     DB  " + Arg$
  INCR TotalData, Len(Arg$) + 1
END IF
END SUB





SUB ChangeQuotedStrings SHARED
LOCAL A
IF INSTR(SourceLine$,CHR$(34)) THEN
  FOR A = 1 TO Tokens
    IF DataType(Stk$(A)) = %StrLit THEN
      AddToLiteralTable Stk$(A)
      IF SharedLiteral$ = "" THEN
        Stk$(A) = "$tring_" + Num$(Literals - %Offset)
      ELSE
        Stk$(A) = SharedLiteral$
      END IF
    END IF
  NEXT
END IF
END SUB



FUNCTION IsFunc(Arg$) SHARED
IsFunc = Instr(Func$, " " + UCASE$(Arg$) + " " )
END FUNCTION




SUB DoArithetic SHARED
LOCAL Channel

'***************************************************************************
'            Tokens is passed in from the main parser in BASM
'***************************************************************************
IF Tokens = 3 AND DataType(Stk$(3)) = %Number THEN EXIT SUB   'optimize size
IF Tokens = 3 AND DataType(Stk$(3)) = %Func   THEN EXIT SUB   'optimize size
'***************************************************************************

IF ArithFlag = %False THEN
  Value$ = "$Var0"
END IF


SELECT CASE Math$

  CASE "+"

  IF Value$ = "1" THEN
    Emit "Inc  AX"
  ELSE
    Emit "Add  AX," + Value$
  END IF


  CASE "-"
  IF Value$ = "1" THEN
    Emit "Dec  AX"
  ELSE
    if ucase$(value$) = "$VAR0" then
      Emit "Neg  AX"
      Emit "Add  AX," + Value$
    ELSE
      Emit "Sub  AX," + Value$
    END IF
  END IF


  CASE "*"
  IF Value$ = "2"  THEN
    Emit "Shl  AX,1"
    Exit Select
  END IF

  IF Value$ = "4"  THEN
    Emit "Shl  AX,2"
    Exit Select
  END IF

  IF Value$ = "8"  THEN
    Emit "Shl  AX,3"
    Exit Select
  END IF

  Emit "Mov  BX," + Value$
  Emit "IMul BX"


  CASE "/"

  IF Value$ = "2"  THEN
    Emit "Shr  AX,1"
    Exit Select
  END IF

  IF Value$ = "4"  THEN
    Emit "Shr  AX,2"
    Exit Select
  END IF

  IF Value$ = "8"  THEN
    Emit "Shr  AX,3"
    Exit Select
  END IF

  Emit "Xor  DX,DX"
  Emit "Mov  CX,"+Value$
  Emit "Idiv CX"

END SELECT
ArithFlag = %False
END SUB





SUB EmitConcatCode SHARED
Use.Concat2 = %True
Emit "Call Concat_2"
Value$ =  ""
END SUB



SUB AddHandleNumber(Arg) SHARED
FOR A = 1 TO 25
  IF FileHandles(a) = Arg THEN EXIT FOR
  IF FileHandles(a) = 0 THEN
    FileHandles(a)  = Arg
    EXIT FOR
  END IF
NEXT
END SUB



SUB ConvertLocalVariableNames SHARED
Local A,ScanLocals,SubName$
IF InProc THEN
  SubName$ = "L_" + REMOVE$(Procname$,"$") + "_"
  FOR A = 2 to Tokens
    FOR ScanLocals = 1 TO LocalTablePtr
      IF UCASE$(Stk$(A)) = LocalTable$(ScanLocals) THEN
        Stk$(A) = SubName$ + Stk$(A)
      END IF
    NEXT
  NEXT
END IF
END SUB




FUNCTION QuikParse(Parameter$)
LOCAL Tmp
SHARED Stk$()
REDIM  Stk$(256)

Lin$      = Parameter$
SaveLine$ = Parameter$

REPLACE CHR$(9) WITH CHR$(32) IN Lin$
Lin$ = RTRIM$(LTRIM$(Lin$))

IF Lin$ = "" THEN
  EXIT FUNCTION
END IF


IF RIGHT$(Lin$,1) = ";" THEN AddSemiColon = %True

SaveLine$ = Lin$
Arglen = LEN(Lin$)


FOR A = 1 TO Arglen

  A$ = MID$(Lin$,A,1)

  IF A$ = Chr$(34) THEN
    IsQuote = NOT IsQuote
  END IF


  IF A$ = "'" THEN
    IF NOT IsQuote THEN
      EXIT FOR
    END IF
  END IF


  IF A$ = " " THEN
    IF IsQuote THEN
      A$ = CHR$(255)         'preserve white space
      IsWhite = -1
      GOTO QuikParseMore
    END IF
  END IF


  IF NOT IsQuote THEN
    SELECT CASE A$

      CASE "%"
      A$ = " "              'change non-quoted integer indicator to white

      CASE ";"
      A$ = " "              'change non-quoted semicolon to white

      CASE ","
      A$ = " "              'change non-quoted comma to white

      CASE "("
      A$ = " "              'change non-quoted left parenth to white

      CASE ")"
      A$ = " "              'change non-quoted right parenth to white

      CASE "["
      A$ = " "              'change non-quoted left bracket to white

      CASE "]"
      A$ = " "              'change non-quoted right bracket to white

      CASE "{"
      A$ = " "              'change non-quoted left curly to white

      CASE "}"
      A$ = " "              'change non-quoted right curly to white

      CASE  "+"
      A$ = " + "            'separate non-quoted plus chars

      CASE  "-"
      A$ = " - "            'separate non-quoted minus chars

      CASE  "*"
      A$ = " * "            'separate non-quoted multiply chars

      CASE  "/"
      A$ = " / "            'separate non-quoted divide chars

      CASE  "="
      A$ = " = "            'separate non-quoted equals chars

      CASE  "<"
      A$ = " < "            'separate non-quoted < chars

      CASE  ">"
      A$ = " > "            'separate non-quoted > chars

      CASE "?"
      A$ = " PRINT "        'expand non-quoted ? chars

      CASE ":"
      A$ = " : "            'separate non-quoted : chars

    END SELECT
  END IF

  QuikParseMore:

  B$ = B$ + A$
NEXT

Lin$ = B$
Lin$ = Trim$(Lin$)

IF Lin$ = "" THEN EXIT FUNCTION            'QUICK EXIT IF NULL

MinusDetected  =    INSTR(Lin$,"-")

DO
  Tmp$ = EXTRACT$(Lin$," ")
  INCR Ndx
  Stk$(Ndx) = Tmp$
  Tmp = Len(Tmp$)
  IF Tmp THEN
    INCR Tmp
    Lin$ = LTRIM$(MID$(Lin$,Tmp))
  ELSE
    DECR Ndx
    EXIT LOOP
  END IF
LOOP


IF MinusDetected THEN
  FOR A = 1 TO Ndx
    IF Stk$(A) = "-" AND IsInteger(Stk$(A + 1)) THEN
      Stk$(A) = Stk$(A) + Stk$(A + 1)
      INCR A
      ARRAY DELETE Stk$(A)
      DECR Ndx
    END IF
  NEXT
END IF


IF UCASE$(Stk$(1)) = "ASM"  THEN
  Parameter$ = SaveLine$
  Stk$(1) = "ASM"
  Ndx = 1
ELSE
  Parameter$ = ""
  FOR Tmp = 1 to Ndx
    Parameter$ = Parameter$ + Stk$(Tmp) + " "
  NEXT
  IF AddSemiColon THEN
    Parameter$ = Parameter$ + " ;"
  END IF
END IF


IF UCASE$(Stk$(1)) = "CONST"  THEN
  Tmp = INSTR(SaveLine$,"=") + 1
  Stk$(1) = "CONST"
  Stk$(4) = MID$(SaveLine$,Tmp)
  Ndx = 4
END IF


IF UCASE$(Stk$(1)) = "INPUT" and NDX = 2 THEN
  Stk$(1) ="INPUT"
  Stk$(3) = Stk$(2)
  Stk$(2) = CHR$(34) + "?" + CHR$(255,34)     'we use 255 instead of 32!
  NDX = 3
  Parameter$ = Stk$(1) + " " + Stk$(2) + " " + Stk$(3)
END IF

IF UCASE$(Stk$(1)) = "SHELL" AND Ndx = 1 THEN
  Stk$(2) = CHR$(34,34)
  Ndx = 2
  Parameter$ = Stk$(1) + " " + Stk$(2)
END IF

QuikParse = Ndx
END FUNCTION




SUB UpdateProcPointer SHARED
IF InProc THEN
  FOR ProcPointer = 1 to ProcCount
    IF Proc$(ProcPointer,1) = ProcName$ THEN EXIT FOR
  NEXT
END IF
END SUB




SUB SwapStackName(Arg$) SHARED
LOCAL Tmp,Limit,A$
'************************************
' This SUB will replace A$ with [BP][##] IF A$ is a
' SUB or FUNCTION Dummy Param Name
'************************************
IF InProc THEN
  A$ = UCASE$(Arg$)
  Limit = Val(Proc$(ProcPointer,2)) + 3
  IF Len(A$) > 0 THEN
    FOR Tmp = 3 TO Limit
      IF A$ = Proc$(ProcPointer,Tmp) THEN
        Arg$ = "Word Ptr[BP+" + Num$( 2 * (Tmp - 2) + MemModel )  + "]"
        EXIT SUB
      END IF
    NEXT
  END IF
END IF
END SUB




FUNCTION IsUsrFunc(Arg$) SHARED
LOCAL Tmp
FOR Tmp = 1 to ProcCount
  IF Proc$(Tmp,1) = UCASE$(Arg$) THEN
    IsUsrFunc = -1
    EXIT FUNCTION
  END IF
NEXT
END FUNCTION





SUB LoadRegister(Register$,Value$)
LOCAL TheDataType

IF MID$(Value$,1,12) = "Word Ptr[BP+" THEN
  Emit "Mov  " + Register$ +  ","  + Value$
  EXIT SUB
END IF

TheDataType = DataType(Value$)

SELECT CASE TheDataType

  CASE %NumVar,%Number
  Emit "Mov  " + Register$ +  "," + Value$
  EXIT SUB

  CASE %StrVar
  Emit "Mov  " + Register$ +  ",Offset " + Value$
  EXIT SUB
END SELECT

END SUB




SUB Push(Value$)
LOCAL TheDataType

IF MID$(Value$,1,12) = "Word Ptr[BP+" THEN
  Emit "Push " + Value$
  EXIT SUB
END IF

TheDataType = DataType(Value$)

SELECT CASE TheDataType

  CASE %NumVar,%Number
  IF IsArray(Value$) THEN
    Emit "Push Offset " + Value$
  ELSE
    Emit "Push " + Value$
  END IF
  EXIT SUB

  CASE %StrVar
  Emit "Push Offset " + Value$
  EXIT SUB
END SELECT

END SUB



FUNCTION Cap$(A$)
Tmp$ = LCASE$(A$)
MID$(Tmp$,1,1) = UCASE$(MID$(Tmp$,1,1))
Cap$ = Tmp$
END FUNCTION



SUB BUILD(A$) SHARED
INCR CodeLines
BasicCode$(CodeLines) = A$
END SUB



SUB PadVar (Var$)
IF LEN(Var$) < 13 THEN
  Var$ = Var$ + SPACE$(13)
  Var$ = Mid$(Var$,1,13)
END IF
END SUB



SUB Check4Array  SHARED
IF Tokens < 4 THEN
  PRINT "Array Variable Expected:"
  PRINT  SourceLine$
  PRINT "Aborting Compilation"
  END
END IF
END SUB



SUB Resolve  (A$) SHARED
IF UCASE$(A$) = "TRUE"  THEN A$ = "-1" : EXIT SUB
IF UCASE$(A$) = "FALSE" THEN A$ = "0"  : EXIT SUB
SwapStackName A$
Hex2Dec       A$

IF IsUsrFunc(A$) THEN EXIT SUB

SELECT CASE A$
'***********************
  CASE "+","-","*","/"
'DO Nothing
'***********************
  CASE ELSE
  A$ = AddVar$(A$)
END SELECT
END SUB



SUB EmitNull
Emit ""
END SUB



FUNCTION IsConst(A$)
SHARED ConstName$()
SHARED ConstantCount

FOR Tmp = 1 to ConstantCount
  IF ConstName$(Tmp) = UCASE$(A$) THEN
    IsConst = -1
    EXIT FUNCTION
  END IF
NEXT

END FUNCTION




FUNCTION GetConstantName$(A$)
SHARED ConstName$()
SHARED ConstantCount

FOR Tmp = 1 to ConstantCount
  IF ConstName$(Tmp) = UCASE$(A$) THEN
    GetConstantName$ = ConstName$(Tmp)
    EXIT FUNCTION
  END IF
NEXT

END FUNCTION




FUNCTION IsArray(A$) SHARED
LOCAL A

IF INSTR(A$,"[BP") > 0 THEN     ' we'll assume it's valid ... :)
  IsArray = -1
  EXIT FUNCTION
END IF

FOR A = 1 TO FarDataCount
  IF UCASE$(EXTRACT$(FarData$(A)," ")) = UCASE$(A$) THEN
    IsArray = -1
    EXIT FUNCTION
  END IF
NEXT
END FUNCTION




SUB CheckColons SHARED
LOCAL A,B
'**************************************************************
' This routine checks for and handles : delimited source lines
'**************************************************************
Colon$ = ""

IF Stacksize = 2 and Stk$(2) = ":" THEN
  StackSize = 1
  Stk$(1) = Stk$(1) + ":"
  EXIT SUB
END IF

FOR A = 1 TO StackSize
  IF Stk$(A) = ":" THEN
    FOR B = A + 1 TO StackSize
      Colon$ = Colon$ + Stk$(B) + " "
    NEXT
    Pass1Line$ = ""
    FOR B = 1 TO A - 1
      Pass1Line$ = Pass1Line$ + Stk$(B) + " "
    NEXT
    StackSize = A - 1
    EXIT SUB
  END IF
NEXT
END SUB



'------------
ERRORHANDLER:
'------------
SELECT CASE ERR
  CASE 53,75,76
  PRINT "Path/File not found"
  CASE 70,71,72,75,76
  PRINT "Problem with disk"
  CASE 7,14,15
  PRINT "Out of Memory"
  CASE ELSE
  PRINT "BASM Fatal Error No.: ";ERR
END SELECT
END


FUNCTION IsProc(A$) SHARED
LOCAL Tmp
For Tmp = 1 to ProcCount
  IF Proc$(Tmp,1) = UCASE$(A$) THEN
    IsProc = -1
    EXIT FUNCTION
  END IF
NEXT
END FUNCTION



SUB Resolve2 Shared
Resolve Stk$(2)
END SUB


SUB Resolve3 Shared
Resolve Stk$(3)
END SUB



SUB Resolve4 Shared
Resolve Stk$(4)
END SUB


SUB Resolve5 Shared
Resolve Stk$(5)
END SUB


SUB Resolve6 Shared
Resolve Stk$(6)
END SUB



SUB ResolvePtr Shared
Resolve Stk$(Ptr)
END SUB



SUB ResolveTmp SHARED
Resolve Tmp$
END SUB


